
 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.YulHelper.Globals"
 import "Homeopatix.YulHelper.MinimizedIcon"
 import "Homeopatix.YulHelper.VindarPatch"
 import "Homeopatix.YulHelper.Commands"
 import "Homeopatix.YulHelper.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>YulHelper</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizeY = tostring(settings.minimizeY);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = settings.shortcutData_1;
   		settings.shortcutData_2 = settings.shortcutData_2;
   		settings.shortcutData_3 = settings.shortcutData_3;
   		settings.shortcutData_4 = settings.shortcutData_4;
   		settings.shortcutData_5 = settings.shortcutData_5;
   
   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "YulHelper_Settings", settings);
end

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
YulHelperWindow=Turbine.UI.Lotro.GoldWindow(); 
YulHelperWindow:SetSize(210,120); 
YulHelperWindow:SetText(Strings.PluginName); 
YulHelperWindow.Message=Turbine.UI.Label(); 
YulHelperWindow.Message:SetParent(YulHelperWindow); 
YulHelperWindow.Message:SetSize(150,15); 
YulHelperWindow.Message:SetPosition(YulHelperWindow:GetWidth()/2 - 75, YulHelperWindow:GetHeight()/2 + 40); 
YulHelperWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
YulHelperWindow.Message:SetText(Strings.PluginText); 
YulHelperWindow:SetWantsKeyEvents(true);

if(settings.isWindowVisible == true) then
	YulHelperWindow:SetVisible(true); 
else
	YulHelperWindow:SetVisible(false); 
end

function YulHelperWindow:Closing(sender, args)
	settings.isWindowVisible = false;
end


YulHelperWindow:SetPosition(settings.positionX, settings.positionY);
if(settings.isWindowVisible == false) then
	YulHelperWindow:SetVisible(false);
else
	YulHelperWindow:SetVisible(true);
end

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, YulHelperWindow:SetVisible(true));

MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- yel helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( YulHelperWindow );
centerWindow:SetPosition( 11 ,YulHelperWindow:GetHeight()/2 - 12);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( YulHelperWindow );
centerWindow2:SetPosition( 49 ,YulHelperWindow:GetHeight()/2 - 12);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow3 = Turbine.UI.Extensions.SimpleWindow();
centerWindow3:SetSize( 36 , 36 );
centerWindow3:SetParent( YulHelperWindow );
centerWindow3:SetPosition( 87,YulHelperWindow:GetHeight()/2 - 12);
centerWindow3:SetVisible( true );
centerWindow3:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow4 = Turbine.UI.Extensions.SimpleWindow();
centerWindow4:SetSize( 36 , 36 );
centerWindow4:SetParent( YulHelperWindow );
centerWindow4:SetPosition( 125,YulHelperWindow:GetHeight()/2 - 12);
centerWindow4:SetVisible( true );
centerWindow4:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow5 = Turbine.UI.Extensions.SimpleWindow();
centerWindow5:SetSize( 36 , 36 );
centerWindow5:SetParent( YulHelperWindow );
centerWindow5:SetPosition( 163,YulHelperWindow:GetHeight()/2 - 12);
centerWindow5:SetVisible( true );
centerWindow5:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow3);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow4);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow5);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);

centerQS3 = Turbine.UI.Lotro.Quickslot();
centerQS3:SetParent( centerWindow3 );
centerQS3:SetPosition( 0, 0 );
centerQS3:SetSize( 35, 35 );
centerQS3:SetUseOnRightClick(false);

centerQS4 = Turbine.UI.Lotro.Quickslot();
centerQS4:SetParent( centerWindow4 );
centerQS4:SetPosition( 0, 0 );
centerQS4:SetSize( 35, 35 );
centerQS4:SetUseOnRightClick(false);

centerQS5 = Turbine.UI.Lotro.Quickslot();
centerQS5:SetParent( centerWindow5 );
centerQS5:SetPosition( 0, 0 );
centerQS5:SetSize( 35, 35 );
centerQS5:SetUseOnRightClick(false);

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------
if(settings.shortcutData_1 ~= "") then
	centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_1, settings.shortcutData_1 ) );
end
if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_2, settings.shortcutData_2 ) );
end
if(settings.shortcutData_3 ~= "") then
	centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_3, settings.shortcutData_3 ) );
end
if(settings.shortcutData_4 ~= "") then
	centerQS4:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_4, settings.shortcutData_4 ) );
end
if(settings.shortcutData_5 ~= "") then
	centerQS5:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_5, settings.shortcutData_5 ) );
end

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end
centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_2 = tmp;

	SaveSettings();
end
centerQS3.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS3:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_3 = tmp;

	SaveSettings();
end
centerQS4.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS4:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_4 = tmp;

	SaveSettings();
end
centerQS5.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS5:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_5 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------

centerQS1.MouseWheel = function(sender, args)
	settings.shortcutData_1 = tostring(""); 
	centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS2.MouseWheel = function(sender, args)
	settings.shortcutData_2 = tostring(""); 
	centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS3.MouseWheel = function(sender, args)
	settings.shortcutData_3 = tostring(""); 
	centerQS3:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS4.MouseWheel = function(sender, args)
	settings.shortcutData_4 = tostring(""); 
	centerQS4:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS5.MouseWheel = function(sender, args)
	settings.shortcutData_5 = tostring(""); 
	centerQS5:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
-------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------

YulHelperWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		YulHelperWindow:SetVisible(false);
		settings.isWindowVisible = false;
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	YulHelperWindow.PositionChanged = function( sender, args )
    	local x,y = YulHelperWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end

				
	



